import java.util.Random;

/*   Kopie der Aufgabenstellung:
Erstelle eine Klasse `TextUndZufall`, die mittels Zufallszahl einen der Namen ausgibt.

Es gibt die Konstante `LISTE_NAMEN` mit Inhalt `"Namensliste Edi Evi Udo Ada Ida Ute Ossi"`.
Diese ist (bis auf das erste Wort) die Quelle der verfügbaren Namen.
ACHTUNG: 

Es gibt folgende `public` Methoden:


* `*String wortNr(int nr)*` ... liefert das N-te Wort zurück. Falls nicht vorhanden, 
  wird `null` geliefert. Intern wird zuerst `findeLeerzeichenNr(...)` aufgerufen, das 
  (nach Erhöhung um 1) die Startposition liefert. 
  Das Ende kann durch nochmaligen Aufruf mit erhöhter Nummer gefunden werden. 
  Das Wort selbst kann entweder mit `substring(...)` oder wieder mit 
  `charAt(...)` extrahiert werden.
 */
/**
 * Erstelle eine Klasse `TextUndZufall`, die mittels Zufallszahl einen der Namen ausgibt.
 * Es gibt die Konstante `LISTE_NAMEN` mit Inhalt `"Namensliste Edi Evi Udo Ada Ida Ute Ossi"`.
 * Diese ist (bis auf das erste Wort) die Quelle der verfügbaren Namen.
 */
public class A3_TextUndZufall
{
    /**
     * String, der nach dem ersten 'Wort' leerzeichen-getrennt eine Namensliste enthält. <br>
     * Die Logik darf NICHT auf den aktuellen Namen basieren!
     */
    public static final String LISTE_NAMEN = "Namen: Ada Adi Edi Evi Ida Udo Ute";
    
    /**
     * Nicht Teil der PLÜ (und noch nicht unterrichtet), aber praktisch zum Testen!
     */
    public static void main(String[] args) {
        A3_TextUndZufall app = new A3_TextUndZufall();
        for (int i = 0; i < 100; i++) {
            if (i > 0 && i % 8 == 0) {
                System.out.println();
            }
            System.out.print(app.zufallsName() + " ");
        }
    }
    
    /**
     * "Hauptmethode" - liefert aus Konstante `LISTE_NAMEN` zufällig einen Namen zurück. <br>
     * <b>Achtung:</b> Erstes Wort ist KEIN Name!<br>
     * Diese nutzt intern nachfolgende Schritte zur Erreichung des Ziels:
     * <ul>
     * <li>Erzeugung Zufallszahlengenerator (`new Random()`).</li>
     * <li>Damit Generieren einer Zufallszahl innerhalb der benötigten Grenzen 
     *     (Feststellung mit {@code anzahlLeerz()} ).</li>
     * <li>damit Aufruf Methode {@code extrahiereNameMitNr(...)}, die intern 
     *     {@code findePositionLeerzNr(...)} nutzt.</li>
     * </ul>
     */
    public String zufallsName() {
        Random randGen = new Random();
        int zz = 1 + randGen.nextInt(anzahlLeerz());
        return extrahiereNameMitNr(zz);
    }
    
    /**
     * 
     */
    public int anzahlLeerz() {
        int lzCount = 0;
        for (int i = 0; i < LISTE_NAMEN.length(); i++) {
            if (LISTE_NAMEN.charAt(i) == ' ') {
                lzCount++;
            }
        }
        return lzCount;
    }
    
    /**
     * Liefert die Position des N-ten (Parameter!) Leerzeichens zurück. <br>
     * Geht mittels String-Methode {@code charAt(...)} zeichenweise den String durch,
     * zählt dabei die angetroffenen Leerzeichen.<br>
     * Sobald die als Parameter gegebene Nummer erreicht ist, wird der aktuelle 
     * Wert der Positionsvariablen (z.B. {@code i}) zurückgeliefert.<br>
     * Falls kein Leerzeichen gefunden wird, wird `-1` geliefert.
     */
    public int findePositionLeerzNr(int leerzNr) {
        int lzCount = 0;
        for (int i = 0; i < LISTE_NAMEN.length(); i++) {
            if (LISTE_NAMEN.charAt(i) == ' ') {
                lzCount++;
            }
            if (lzCount == leerzNr) {
                return i;
            }
        }
        return -1;
    }
    
    /**
     * Liefert den N-ten Namen aus der String-Konstanten zurück. <br>
     * Falls zu hohe Nummer übergeben, wird null geliefert.<br>
     * Intern wird zuerst findePositionLeerzNr(...) aufgerufen, das (nach Erhöhung 
     * um 1) die Startposition liefert. <br>
     * Das Ende kann durch nochmaligen Aufruf mit um eins erhöhter Nummer gefunden werden.<br>
     * Das Wort selbst kann entweder mit substring(...) oder wieder mit charAt(...)
     * extrahiert werden.
     */
    public String extrahiereNameMitNr(int wortNr) {
        int lzAnfg = findePositionLeerzNr(wortNr);
        int lzEnde = findePositionLeerzNr(wortNr + 1);
        if (lzEnde < 0) {
            lzEnde = LISTE_NAMEN.length();
        }
        return LISTE_NAMEN.substring(lzAnfg + 1, lzEnde);
    }
}
